//+------------------------------------------------------------------+
//|                                                xpPivotAlerts.mq4 |
//|                                         Developed by Coders Guru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+
#property link      "http://www.xpworx.com"
//Stamp_Version  = "Last Modified: 2010.10.15 19:30";

//modified by sangmane at Jan 26, 2011
//fixing indicator from deleting all object drawn by other indicators

#property indicator_chart_window
#property indicator_buffers 7

double R = 0;
double p = 0;
double r3 = 0;
double r2 = 0;
double r1 = 0;
double s1 = 0;
double s2 = 0;
double s3 = 0;

extern bool AlertsOn = true;
extern bool AlertsEmail = false;
extern bool PivotLineCrossAlert = true;
extern bool R1LineCrossAlert = true;
extern bool R2LineCrossAlert = true;
extern bool R3LineCrossAlert = true;
extern bool S1LineCrossAlert = true;
extern bool S2LineCrossAlert = true;
extern bool S3LineCrossAlert = true;

extern color PivotColor = DimGray;
extern color R1Color = DarkGreen;
extern color R2Color = DarkGreen;
extern color R3Color = DarkGreen;
extern color S1Color = FireBrick;
extern color S2Color = FireBrick;
extern color S3Color = FireBrick;

extern int PivotWidth = 3;
extern int R1Width = 1;
extern int R2Width = 1;
extern int R3Width = 1;
extern int S1Width = 1;
extern int S2Width = 1;
extern int S3Width = 1;


double buf0[] , buf1[], buf2[], buf3[], buf4[], buf5[], buf6[];


int init()
{
   SetIndexBuffer(0,buf0);
   SetIndexBuffer(1,buf1);
   SetIndexBuffer(2,buf2);
   SetIndexBuffer(3,buf3);
   SetIndexBuffer(4,buf4);
   SetIndexBuffer(5,buf5);
   SetIndexBuffer(6,buf6);
   SetIndexLabel(0, "Pivot");
   SetIndexLabel(1, "Resistance 1");
   SetIndexLabel(2, "Resistance 2");
   SetIndexLabel(3, "Resistance 3");
   SetIndexLabel(4, "Support 1");
   SetIndexLabel(5, "Support 2");
   SetIndexLabel(6, "Support 3");
   
   return(0);
}

int deinit()
{
	string objname;
	for(int i=ObjectsTotal()-1; i>=0; i--) {
		objname = ObjectName(i);
		if(StringFind(objname,WindowExpertName(),0)==0) ObjectDelete(objname);
	}
   //ObjectsDeleteAll();
   return(0);
}

void start()
{
   Draw_Pivots();
   if (AlertsOn) AlertCrosses();
   return;
}

void Draw_Pivots()
{

   double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
   ArrayCopyRates(rates, Symbol(), PERIOD_D1);

   if(DayOfWeek() == 1)
   {
      if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
      {
          yesterday_close = rates[1][4];
          yesterday_high = rates[1][3];
          yesterday_low = rates[1][2];
      }
      else
      {
         for(int d = 5;d>=0;d--)
         {
            if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
            {
                yesterday_close = rates[d][4];
                yesterday_high = rates[d][3];
                yesterday_low = rates[d][2];
            }
         
         }  
      }
   }
   else
   {
       yesterday_close = rates[1][4];
       yesterday_high = rates[1][3];
       yesterday_low = rates[1][2];
   }


   //---- Calculate Pivots

   R = yesterday_high - yesterday_low;//range

   p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
   r3 = yesterday_high + 2 * (p - yesterday_low);
   r2 = p + ((p * 2) - yesterday_low - ((p * 2) - yesterday_high));
   r1 = (p * 2) - yesterday_low;
   s1 = (p * 2) - yesterday_high;
   s2 = p - ((p * 2) - yesterday_low - ((p * 2) - yesterday_high));
   s3 = yesterday_low - 2 * (yesterday_high - p);

   drawLine(r3,"R3", R3Color,0,R3Width);
   drawLabel("Resistance 3",r3,R3Color);
   drawLine(r2,"R2", R2Color,0,R2Width);
   drawLabel("Resistance 2",r2,R2Color);
   drawLine(r1,"R1", R1Color,0,R1Width);
   drawLabel("Resistance 1",r1,R1Color);

   drawLine(p,"PIVIOT",PivotColor,1,PivotWidth);
   drawLabel("Piviot level",p,PivotColor);

   drawLine(s1,"S1",S1Color,0,S1Width);
   drawLabel("Support 1",s1,S1Color);
   drawLine(s2,"S2",S2Color,0,S2Width);
   drawLabel("Support 2",s2,S2Color);
   drawLine(s3,"S3",S3Color,0,S3Width);
   drawLabel("Support 3",s3,S3Color);
   
   WindowRedraw();
   
   for (int i = 0; i < 100; i++) 
   {
      buf0[i] = p;
      buf1[i] = r1;
      buf2[i] = r2;
      buf3[i] = r3;
      buf4[i] = s1;
      buf5[i] = s2;
      buf6[i] = s3;
   }
}

void drawLabel(string name,double lvl,color Color)
{
	name = WindowExpertName()+name;
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 10, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}

void drawLine(double lvl,string name, color Col,int type,int width)
{
		name = WindowExpertName()+name;
         if(ObjectFind(name) == -1)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            if(type == 1)
            ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
            else
            ObjectSet(name, OBJPROP_STYLE, STYLE_DOT);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
          
         }
         WindowRedraw();
}  

bool AlertOnce(string alert_msg, int ref)
{  
   static int LastAlert[10];
   
   if( LastAlert[ref] == 0 || LastAlert[ref] < Bars)
   {
      Alert(alert_msg);
      LastAlert[ref] = Bars;
         if (AlertsEmail) SendMail("xpPivotAlerts",alert_msg);
      return (true);
   }
   return(false);
}


void AlertCrosses()
{
 /*  
   extern bool PivotLineCrossAlert = true;
   extern bool R1LineCrossAlert = true;
   extern bool R2LineCrossAlert = true;
   extern bool R3LineCrossAlert = true;
   extern bool S1LineCrossAlert = true;
   extern bool S2LineCrossAlert = true;
   extern bool S3LineCrossAlert = true;

      buf0[i] = p;
      buf1[i] = r1;
      buf2[i] = r2;
      buf3[i] = r3;
      buf4[i] = s1;
      buf5[i] = s2;
      buf6[i] = s3;
*/

   if(PivotLineCrossAlert && Low[0] < p && High[0] > p) 
   AlertOnce("Pivot - Price touched Pivot line  @ "+Symbol()+"-"+PeriodToText(),0);

   if(R1LineCrossAlert && Low[0] < r1 && High[0] > r1) 
   AlertOnce("R1 - Price touched R1 line  @ "+Symbol()+"-"+PeriodToText(),1);
   
   if(R2LineCrossAlert && Low[0] < r2 && High[0] > r2) 
   AlertOnce("R2 - Price touched R2 line  @ "+Symbol()+"-"+PeriodToText(),2);
   
   if(R3LineCrossAlert && Low[0] < r3 && High[0] > r3) 
   AlertOnce("R3 - Price touched R3 line  @ "+Symbol()+"-"+PeriodToText(),3);
   
   if(S1LineCrossAlert && Low[0] < s1 && High[0] > s1) 
   AlertOnce("S1 - Price touched S1 line  @ "+Symbol()+"-"+PeriodToText(),4);
   
   if(S2LineCrossAlert && Low[0] < s2 && High[0] > s2) 
   AlertOnce("S2 - Price has touched S2 line  @ "+Symbol()+"-"+PeriodToText(),5);
   
   if(S3LineCrossAlert && Low[0] < s3 && High[0] > s3) 
   AlertOnce("S3 - Price touched S3 line  @ "+Symbol()+"-"+PeriodToText(),6);
}

string PeriodToText()
{
   switch (Period())
   {
      case 1:
            return("M1");
            break;
      case 5:
            return("M5");
            break;
      case 15:
            return("M15");
            break;
      case 30:
            return("M30");
            break;
      case 60:
            return("H1");
            break;
      case 240:
            return("H4");
            break;
      case 1440:
            return("D1");
            break;
      case 10080:
            return("W1");
            break;
      case 43200:
            return("MN1");
            break;
   }
   return("");
}


